#include "mpg123.h"

void fill_songinfo_struct_mp3(gchar *filename);

int main(int argc, char **argv) {

    if (argc < 2) {
        printf("Specify filename!\n");
        exit(0);
    }

    int i;
    for (i=1; argv[i] != NULL ; i++) {
        fill_songinfo_struct_mp3(argv[i]);
        printf("NEXT IN FOR\n");
    }
}


void fill_songinfo_struct_mp3(gchar *filename) {
        
        /* code mainly from xmms */
        
        printf("start\n");
        struct id3v1tag_t tag; 
        FILE *fh;
        gint i;
        
        memset(&tag, 0, sizeof(tag));
                
        if ((fh = fopen(filename, "rb")) != NULL) {

                guint32 head;
	        unsigned char tmp[4];
	        struct frame frm;
	        gboolean id3_found = FALSE;

	        fseek(fh, -sizeof (tag), SEEK_END);
		if (fread(&tag, 1, sizeof (tag), fh) == sizeof (tag))
		{
			if ((strncmp(tag.tag, "TAG", 3)) == 0)
			{
				id3_found = TRUE;
				printf("tag.title: %s\n\n", tag.title);
				printf("tag.artist: %s\n\n", tag.artist);
				printf("tag.album: %s\n\n", tag.album);
				printf("tag.year: %c%c%c%c\n", tag.year[0], tag.year[1], tag.year[2], tag.year[3]);
				
                                /* Check for v1.1 tags */
				if (tag.u.v1_1.__zero == 0)
				{
					printf("id3tag v1.1\n");
                                        printf("tag.u.v1_1.tracknumber: %d\n",tag.u.v1_1.track_number);
                                        printf("tag.u.v1_1.comment: %s\n", tag.u.v1_1.comment);
				}
				else
				{
					printf("id3tag v1.0\n");
                                        printf("tag.u.v1_0.comment: %s\n", tag.u.v1_0.comment);
                                }
				printf("genre: %s\n",mpg123_id3_genres[tag.genre]);    
                                
			}
		}

                rewind(fh);
                printf("middle\n");
		if (fread(tmp, 1, 4, fh) != 4)
		{
			fclose(fh);
			return;
		}
		head = ((guint32) tmp[0] << 24) | ((guint32) tmp[1] << 16) | ((guint32) tmp[2] << 8) | (guint32) tmp[3];
		while (!mpg123_head_check(head))
		{
			head <<= 8;
			if (fread(tmp, 1, 1, fh) != 1)
			{
				fclose(fh);
				return;
			}
			head |= tmp[0];
		}
		if (mpg123_decode_header(&frm, head))
		{
			guchar *buf;
			gdouble tpf;
			gint pos;
			XHEADDATA xing_header;
                        //xing_header_t xing_header;
			guint32 num_frames;
                        
                        printf("FRAMESIZE: %d\n",frm.framesize);
			buf = g_malloc(frm.framesize + 4);
			fseek(fh, -4, SEEK_CUR);
			fread(buf, 1, frm.framesize + 4, fh);
			tpf = mpg123_compute_tpf(&frm);
			//set_mpeg_level_label(frm.mpeg25, frm.lsf, frm.lay);
			pos = ftell(fh);
			fseek(fh, 0, SEEK_END);

                        if (mpg123_get_xing_header(&xing_header, buf))
			{
				num_frames = xing_header.frames;
				printf("Bitrate: Variable\n");
                                printf("Avg bitrate: %d kb/sec\n", (gint) ((xing_header.bytes * 8) / (tpf * xing_header.frames * 1000)));
			        printf("Sample rate: %d\n",xing_header.samprate);
                        }
			else
			{
                                num_frames = ((ftell(fh) - pos - (id3_found ? 128 : 0)) / mpg123_compute_bpf(&frm)) + 1;
				printf("Bitrate: Constant\n");
                                printf("Bitrate: %d\n", tabsel_123[frm.lsf][frm.lay - 1][frm.bitrate_index]);
                                printf("Samplerate: %ld Hz\n", mpg123_freqs[frm.sampling_frequency]);
                        }

                                printf("Chan mode: %s\n", channel_mode[frm.mode]);
                        gint time=0, min=0, sec=0;
                        printf("Frames: %d\n",num_frames);
                        printf("Filesize: %d bytes\n",ftell(fh));
                        time = mpg123_get_song_time(fh);
                        min = time / 1000 / 60;
                        printf("min = %d\n",min);
                        sec = (time/1000) % 60;
                        printf("sec = %d\n",sec);
                        g_free(buf);
		}
                fclose(fh);
	}
}
