#include "amp.h"

void cli_add_song_to_job(GList *joblist, gint jobnr, gchar *path, gint position, gboolean played, struct songinfo *info) {
  
  /* if called with negative value at position the song will be
   * added in the end of the list. negative jobnr will add songs
   * to the last job */
   
  if (joblist == NULL)
      return;
    
  GList *liststart = joblist;
  struct songqueue *sqp;
  
  if (jobnr < 0) {
      joblist = g_list_last(joblist);
  }
  else if ((joblist = g_list_nth(joblist, jobnr)) == NULL) {
      joblist = liststart;
      return;
  }
  

  sqp = (struct songqueue *) g_malloc0(sizeof(struct songqueue));
  sqp -> path = g_strdup(path);
  sqp -> played = played;
  
  sqp -> info = (struct songinfo *) g_malloc0(sizeof(struct songinfo));
  memcpy(sqp -> info, info, sizeof(struct songinfo));
  
  struct jobqueue *tmp = joblist -> data;
  tmp -> songqueue = g_list_insert(tmp -> songqueue, (struct songqueue *) sqp, position);
  
  joblist = liststart;
  return;

}
GList *cli_add_highprio_song(GList *highprio_list, gchar *path, gint position, gboolean played, struct songinfo *info) {
  
  /* high priority, these will ALWAYS play first */
  
  /* if called with negative value at position the song will be
   * added in the end of the list */
  
  struct songqueue *sqp;
  
  sqp = (struct songqueue *) g_malloc(sizeof(struct songqueue));
  sqp -> path = g_strdup(path);
  sqp -> played = played;
  
  sqp -> info = (struct songinfo *) g_malloc0(sizeof(struct songinfo));
  memcpy(sqp -> info, info, sizeof(struct songinfo));
  
  highprio_list = g_list_insert(highprio_list, (struct songqueue *) sqp, position);
  
  return highprio_list;
}


