#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <fcntl.h>
#include <sys/wait.h>
#include <signal.h>

#include "amp.h"

void ext_player(char *player, char *opts, struct currently_playing *cp);
void ext_player_communication(gint fd, gint command, gint value);
//gchar *ext_player_info(gchar *info);

static void sigchld_handler(int status);

//gchar info[] =  "MPlayer output plugin.\n\0";


void ext_player(char *player, char *opts, struct currently_playing *cp) {

  int sv[2];
  int a=0;
  char *tmpopts;
  char *p;

  //printf("ext_player()\n");
  
  /* exit if no path to mplayer or song is missing */
  if (!(player || cp->song->path))
     return;
  /* we need to be able to change spaces to NULL */
  tmpopts = (char *) malloc(strlen(opts)+10);
  strcpy(tmpopts,opts);
  
  p = opts;
  /* count how many opts we have */
  while ((p = strchr(p,32)) != NULL) {
    a++;
    p++;
  }
  if (a > 0) a++;

  /* for execve */ 
  char *arg[a+3];
  
  arg[a+2] = NULL;
  arg[a+1] = cp->song->path;
  
  while ((p = strrchr(tmpopts,32)) != NULL) {
    *p = 0;
    p++;
    arg[a] = p;
    a--;
    if (a == 1) arg[a] = tmpopts;
  }
  
  arg[0] = player;
/*
  for (a=0; arg[a] != NULL; a++) 
    printf("arg[%d] = '%s'\n",a,arg[a]);
*/  
  
  socketpair(AF_UNIX, SOCK_STREAM, 0, sv);

  signal(SIGCHLD, sigchld_handler);

  if (fork() == 0) {
    /* the child is going to execute the player */ 
    close(sv[1]);
    dup2(sv[0],0);
    dup2(sv[0],1);
    dup2(open("/dev/null", O_WRONLY),2);

    execve(arg[0],arg,NULL);
    free(tmpopts);
    close(sv[0]);
    exit(0);
  
  }
  
  close(sv[0]);
  
  int i;
  //int oldtime = -1;
  fd_set rfds;
  char pbuf[512]; /* from player */
  char sbuf[128]; /* from server */
  
  FD_ZERO(&rfds);
  
   while(1) {
       memset(&pbuf,0,sizeof(pbuf));
       memset(&sbuf,0,sizeof(sbuf));
    
       FD_SET(sv[1],&rfds);       /* sv[1] is stdout of the player */
       FD_SET(cp->fd[0],&rfds);   /* commands to send to player from server */
    
       if ((select(sv[1]+1, &rfds, NULL, NULL, NULL)) > 0) {
           if (FD_ISSET(sv[1], &rfds)) {
               if ((read(sv[1], pbuf, sizeof(pbuf)-1)) <= 0) {
                   //printf("FEEEEEEEEL!\n");
                   free(tmpopts);
                   return;
               }
               if ((p = strstr(pbuf,"A:")) != NULL) {
                   for (i = 2; isdigit(p[i]) == 0 ; i++);
                   cp -> time = atoi(pbuf+i);
                   //printf("%d\n",cp->time);
               } 
               //else if ((strstr(pbuf,"Exiting"))) {
               //    printf("MPlayer done...\n");
               //    free(tmpopts);
               //    return;
               //}
           }
           if (FD_ISSET(cp->fd[0],&rfds)) {
               read(cp->fd[0],sbuf, sizeof(sbuf)-1);
               write(sv[1],sbuf,strlen(sbuf));
           }
       }
   }
}

void ext_player_communication(gint fd, gint command, gint value) {
    
    gchar *seek;
    seek = g_strdup_printf("seek %d 1\n",value);
   
    switch (command) {
       case STOP:
           write(fd,"quit\n",5);
           break;
       case PAUSE:
           write(fd,"pause\n",6);
           break;
       case SEEK:
           write(fd,seek,strlen(seek));
           break;
    }

    g_free(seek);
}
/*
gchar *ext_player_info(gchar *info) {

   info = g_strdup_printf("MPlayer output plugin.");
   return info;
}
*/
static void sigchld_handler(int status) {

    while(waitpid(-1, &status, WNOHANG) > 0);
}
