

typedef struct jobqueue {
    gchar       *name;      
    gboolean    random;   /* TRUE for random, FALSE for sequence. */
    GList       *songqueue;
} jobqueue;

typedef struct songqueue {
    gchar           *path;
    gboolean        played;  /* TRUE if the song has been played. */
    struct songinfo *info;
} songqueue;

typedef struct jobstatus {
    gint        total_songs;
    gint        played;
} jobstatus;


/* If there are songs in the highprio_list these will be played first
   in the order they are put there.
   
   If the highprio_list is empty OR all songs are marked as played it
   will start with the first job in joblist.
*/



/* function declares */

GList *add_job(GList *joblist, gchar *name, gboolean random, gint position);
//void add_song_to_job(GList *joblist, gint jobnr, gchar *path, gint position, gboolean played, gboolean server);
void print_hierachy(GList *joblist);   /* debug function */
void remove_songqueue_element(GList *joblist, gint jobnr, gint songnr);
void free_songqueue_data(gpointer element);
void free_jobqueue_data(gpointer element);
GList *remove_jobqueue_element(GList *joblist, gint jobnr);
//GList *add_highprio_song(GList *joblist, gchar *path, gint position, gboolean played);
struct songqueue *get_queued_song(GList *joblist, GList *highprio_list);
gboolean songs_to_play_in_job(GList *joblist, gint jobnr);
struct songqueue *sequence_play(struct jobqueue *jtmp);
struct songqueue *random_play(struct jobqueue *jtmp);
void get_current_jobstatus(GList *joblist, struct jobstatus *jstat);
void get_current_hpstatus(GList *highprio_list, struct jobstatus *jstat);
void jobstat(gpointer data, gpointer jobstat); /* called from get_current_jobstatus() */
//void srv_save_songinfo_to_sq(struct songqueue *sqp);

    

