#include <amp.h>

void srv_log(guint loglevel, gchar *msg) {


    if (servcfg->loglevel >= loglevel) {
        gchar *date = NULL;
        g_print("%s  %s\n", logtime(date), msg);
        g_free(date);
    }
    return;

}

gchar *logtime(gchar *str) {
    /* returns gchar* to date in format ex.:  Jan 5  [08:45] 
     * called from srv_log()
     */
    
    time_t	t;
    struct tm	*tmt;
    gchar       month[4];
    
    memset(&month, 0, 4);
    
    t = time(NULL);
    tmt = localtime(&t);
    
    switch (tmt->tm_mon) {
        case 0:
            memcpy(month,"Jan",3);
            break;
        case 1:
            memcpy(month,"Feb",3);
            break;
        case 2:
            memcpy(month,"Mar",3);
            break;
        case 3:
            memcpy(month,"Apr",3);
            break;
        case 4:
            memcpy(month,"May",3);
            break;
        case 5:
            memcpy(month,"Jun",3);
            break;
        case 6:
            memcpy(month,"Jul",3);
            break;
        case 7:
            memcpy(month,"Aug",3);
            break;
        case 8:
            memcpy(month,"Sep",3);
            break;
        case 9:
            memcpy(month,"Oct",3);
            break;
        case 10:
            memcpy(month,"Nov",3);
            break;
        case 11:
            memcpy(month,"Dec",3);
            break;
    }
  
    str = g_strdup_printf("%s %-d  [%.2d:%.2d:%.2d] ", month, tmt->tm_mday, tmt->tm_hour, tmt->tm_min, tmt->tm_sec);
  
    return str;
}


void srv_playlog(gchar *logfile, gchar *song) {

    FILE *fp;

    srv_log(2,"srv_playlog()");
    if ((fp = fopen(logfile, "a")) == NULL) {
        srv_log(1, "Playlog error: fopen()");
        return;
    }
    chmod(logfile, PLAYLOG_PERMS);
    
    gchar *date = NULL;
    gchar *tmp = g_strdup_printf("%s %s\n", logtime(date), song);
    g_free(date);
    fputs(tmp, fp);
    g_free(tmp);

    fclose(fp);
    return;
}
   
 
       
